Index: src/Actions/SelectionAction/NotAtomByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotAtomByIdAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/SelectionAction/NotAtomByIdAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,28 +11,6 @@
 #include "Actions/Action.hpp"
 
-class atom;
-
-void SelectionNotAtomById(atom *_atom);
-
-class SelectionNotAtomByIdAction : public Action {
-  friend void SelectionNotAtomById(atom *_atom);
-
-public:
-  SelectionNotAtomByIdAction();
-  virtual ~SelectionNotAtomByIdAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotAtomByIdAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTATOMBYIDACTION_HPP_ */
Index: src/Actions/SelectionAction/NotMoleculeByFormulaAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByFormulaAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/NotMoleculeByFormulaAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,83 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * NotMoleculeByFormulaAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Descriptors/MoleculeFormulaDescriptor.hpp"
+#include "molecule.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/SelectionAction/NotMoleculeByFormulaAction.hpp"
+
+// and construct the stuff
+#include "NotMoleculeByFormulaAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionNotMoleculeByFormulaAction::performCall() {
+  std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
+
+  // obtain information
+  getParametersfromValueStorage();
+
+  DoLog(1) && (Log() << Verbose(1) << "Unselecting molecules with chemical formula " << params.formula << ":" << endl);
+  std::vector<molecule *> matchingMolecules = World::getInstance().getAllMolecules(MoleculeByFormula(params.formula));
+  for (std::vector<molecule *>::const_iterator iter = matchingMolecules.begin(); iter != matchingMolecules.end(); ++iter) {
+    DoLog(1) && (Log() << Verbose(1) << "\t" << (*iter)->getId() << ", " << (*iter)->getName() << "." << endl);
+  }
+  World::getInstance().unselectAllMolecules(MoleculeByFormula(params.formula));
+  return Action::state_ptr(new SelectionNotMoleculeByFormulaState(selectedMolecules,params));
+}
+
+Action::state_ptr SelectionNotMoleculeByFormulaAction::performUndo(Action::state_ptr _state) {
+  SelectionNotMoleculeByFormulaState *state = assert_cast<SelectionNotMoleculeByFormulaState*>(_state.get());
+
+  World::getInstance().clearMoleculeSelection();
+  for(std::vector<molecule *>::iterator iter = state->selectedMolecules.begin(); iter != state->selectedMolecules.end(); ++iter)
+    World::getInstance().selectMolecule(*iter);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr SelectionNotMoleculeByFormulaAction::performRedo(Action::state_ptr _state){
+  SelectionNotMoleculeByFormulaState *state = assert_cast<SelectionNotMoleculeByFormulaState*>(_state.get());
+
+  World::getInstance().unselectAllMolecules(MoleculeByFormula(state->params.formula));
+
+  return Action::state_ptr(_state);
+}
+
+bool SelectionNotMoleculeByFormulaAction::canUndo() {
+  return true;
+}
+
+bool SelectionNotMoleculeByFormulaAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionNotMoleculeByFormulaAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotMoleculeByFormulaAction.def
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByFormulaAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/NotMoleculeByFormulaAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * NotMoleculeByFormulaAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class molecule;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (SelectionNotMoleculeByFormulaAction::NAME)
+#define paramreferences (formula)
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotMoleculeByFormula
+#define TOKEN "unselect-molecule-by-formula"
+
Index: src/Actions/SelectionAction/NotMoleculeByFormulaAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByFormulaAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/NotMoleculeByFormulaAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,16 @@
+/*
+ * NotMoleculeByFormulaAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef NOTMOLECULEBYFORMULAACTION_HPP_
+#define NOTMOLECULEBYFORMULAACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+#include "NotMoleculeByFormulaAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* NOTMOLECULEBYFORMULAACTION_HPP_ */
Index: src/Actions/SelectionAction/NotMoleculeByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByIdAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/SelectionAction/NotMoleculeByIdAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * NotMoleculeByIdAction.cpp
@@ -6,11 +13,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/NotMoleculeByIdAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "molecule.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -20,50 +30,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/NotMoleculeByIdAction.hpp"
 
+// and construct the stuff
+#include "NotMoleculeByIdAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionNotMoleculeByIdAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionNotMoleculeByIdState : public ActionState {
-public:
-  SelectionNotMoleculeByIdState(molecule* _mol) :
-    mol(_mol)
-  {}
-  molecule* mol;
-};
-
-const char SelectionNotMoleculeByIdAction::NAME[] = "unselect-molecule-by-id";
-
-SelectionNotMoleculeByIdAction::SelectionNotMoleculeByIdAction() :
-  Action(NAME)
-{}
-
-SelectionNotMoleculeByIdAction::~SelectionNotMoleculeByIdAction()
-{}
-
-void SelectionNotMoleculeById(molecule *_mol) {
-  ValueStorage::getInstance().setCurrentValue(SelectionNotMoleculeByIdAction::NAME, _mol);
-  ActionRegistry::getInstance().getActionByName(SelectionNotMoleculeByIdAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* SelectionNotMoleculeByIdAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryMolecule(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionNotMoleculeByIdAction::performCall() {
-  molecule *mol = NULL;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, mol);
-
-  if (World::getInstance().isSelected(mol)) {
-    DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule " << mol->name << endl);
-    World::getInstance().unselectMolecule(mol);
-    return Action::state_ptr(new SelectionNotMoleculeByIdState(mol));
+  if (World::getInstance().isSelected(params.mol)) {
+    DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule " << params.mol->name << endl);
+    World::getInstance().unselectMolecule(params.mol);
+    return Action::state_ptr(new SelectionNotMoleculeByIdState(params));
   } else {
     return Action::success;
@@ -74,8 +52,8 @@
   SelectionNotMoleculeByIdState *state = assert_cast<SelectionNotMoleculeByIdState*>(_state.get());
 
-  if (state->mol != NULL)
-    World::getInstance().selectMolecule(state->mol);
+  if (state->params.mol != NULL)
+    World::getInstance().selectMolecule(state->params.mol);
 
-  return Action::state_ptr(new SelectionNotMoleculeByIdState(state->mol));
+  return Action::state_ptr(_state);
 }
 
@@ -83,8 +61,8 @@
   SelectionNotMoleculeByIdState *state = assert_cast<SelectionNotMoleculeByIdState*>(_state.get());
 
-  if (state->mol != NULL)
-    World::getInstance().unselectMolecule(state->mol);
+  if (state->params.mol != NULL)
+    World::getInstance().unselectMolecule(state->params.mol);
 
-  return Action::state_ptr(new SelectionNotMoleculeByIdState(state->mol));
+  return Action::state_ptr(_state);
 }
 
@@ -100,2 +78,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotMoleculeByIdAction.def
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByIdAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/NotMoleculeByIdAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * NotMoleculeByIdAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class molecule;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (molecule*)
+#define paramtokens (SelectionNotMoleculeByIdAction::NAME)
+#define paramreferences (mol)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotMoleculeById
+#define TOKEN "unselect-molecule-by-id"
+
Index: src/Actions/SelectionAction/NotMoleculeByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByIdAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/SelectionAction/NotMoleculeByIdAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,28 +11,6 @@
 #include "Actions/Action.hpp"
 
-class molecule;
-
-void SelectionNotMoleculeById(molecule *_mol);
-
-class SelectionNotMoleculeByIdAction : public Action {
-  friend void SelectionNotMoleculeById(molecule *_mol);
-
-public:
-  SelectionNotMoleculeByIdAction();
-  virtual ~SelectionNotMoleculeByIdAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "NotMoleculeByIdAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* NOTMOLECULEBYIDACTION_HPP_ */
Index: src/Actions/SelectionAction/NotMoleculeOfAtomAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeOfAtomAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/NotMoleculeOfAtomAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,78 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * NotMoleculeOfAtomAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Descriptors/MoleculeDescriptor.hpp"
+#include "atom.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/SelectionAction/NotMoleculeOfAtomAction.hpp"
+
+// and construct the stuff
+#include "NotMoleculeOfAtomAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionNotMoleculeOfAtomAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
+
+  std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
+  DoLog(1) && (Log() << Verbose(1) << "Unselecting molecule to which " << params.Walker->getName() << " belongs." << endl);
+  World::getInstance().unselectMoleculeOfAtom(params.Walker);
+  return Action::state_ptr(new SelectionNotMoleculeOfAtomState(selectedMolecules, params));
+}
+
+Action::state_ptr SelectionNotMoleculeOfAtomAction::performUndo(Action::state_ptr _state) {
+  SelectionNotMoleculeOfAtomState *state = assert_cast<SelectionNotMoleculeOfAtomState*>(_state.get());
+
+  World::getInstance().clearMoleculeSelection();
+  for(std::vector<molecule *>::iterator iter = state->selectedMolecules.begin(); iter != state->selectedMolecules.end(); ++iter)
+    World::getInstance().selectMolecule(*iter);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr SelectionNotMoleculeOfAtomAction::performRedo(Action::state_ptr _state){
+  SelectionNotMoleculeOfAtomState *state = assert_cast<SelectionNotMoleculeOfAtomState*>(_state.get());
+
+  World::getInstance().unselectMoleculeOfAtom(state->params.Walker);
+
+  return Action::state_ptr(_state);
+}
+
+bool SelectionNotMoleculeOfAtomAction::canUndo() {
+  return true;
+}
+
+bool SelectionNotMoleculeOfAtomAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionNotMoleculeOfAtomAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/NotMoleculeOfAtomAction.def
===================================================================
--- src/Actions/SelectionAction/NotMoleculeOfAtomAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/NotMoleculeOfAtomAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,24 @@
+/*
+ * NotMoleculeOfAtomAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (atom*)
+#define paramtokens (SelectionNotMoleculeOfAtomAction::NAME)
+#define paramreferences (Walker)
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME NotMoleculeOfAtom
+#define TOKEN "unselect-molecule-of-atom"
+
Index: src/Actions/SelectionAction/NotMoleculeOfAtomAction.hpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeOfAtomAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/NotMoleculeOfAtomAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,16 @@
+/*
+ * NotMoleculeOfAtomAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef NOTMOLECULEOFATOMSACTION_HPP_
+#define NOTMOLECULEOFATOMSACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+#include "NotMoleculeOfAtomAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* NOTMOLECULEOFATOMSACTION_HPP_ */
Index: src/Actions/TesselationAction/ConvexEnvelopeAction.cpp
===================================================================
--- src/Actions/TesselationAction/ConvexEnvelopeAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/TesselationAction/ConvexEnvelopeAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ConvexEnvelopeAction.cpp
@@ -6,14 +13,18 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/TesselationAction/ConvexEnvelopeAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "boundary.hpp"
 #include "config.hpp"
 #include "linkedcell.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
-#include "verbose.hpp"
+#include "tesselation.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -23,56 +34,17 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/TesselationAction/ConvexEnvelopeAction.hpp"
 
-/****** TesselationConvexEnvelopeAction *****/
-
-// memento to remember the state when undoing
-
-//class TesselationConvexEnvelopeState : public ActionState {
-//public:
-//  TesselationConvexEnvelopeState(molecule* _mol,std::string _lastName) :
-//    mol(_mol),
-//    lastName(_lastName)
-//  {}
-//  molecule* mol;
-//  std::string lastName;
-//};
-
-const char TesselationConvexEnvelopeAction::NAME[] = "convex-envelope";
-
-TesselationConvexEnvelopeAction::TesselationConvexEnvelopeAction() :
-  Action(NAME)
-{}
-
-TesselationConvexEnvelopeAction::~TesselationConvexEnvelopeAction()
-{}
-
-void TesselationConvexEnvelope(std::string &filenameConvex, std::string &filenameNonConvex) {
-  ValueStorage::getInstance().setCurrentValue("convex-file", filenameConvex);
-  ValueStorage::getInstance().setCurrentValue("nonconvex-file", filenameConvex);
-  ActionRegistry::getInstance().getActionByName(TesselationConvexEnvelopeAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* TesselationConvexEnvelopeAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-  dialog->queryString("convex-file", ValueStorage::getInstance().getDescription("convex-file"));
-  dialog->queryString("nonconvex-file", ValueStorage::getInstance().getDescription("nonconvex-file"));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "ConvexEnvelopeAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr TesselationConvexEnvelopeAction::performCall() {
-  string filenameConvex;
-  string filenameNonConvex;
   molecule * mol = NULL;
   bool Success = true;
   config *configuration = World::getInstance().getConfig();
 
-  ValueStorage::getInstance().queryCurrentValue("convex-file", filenameConvex);
-  ValueStorage::getInstance().queryCurrentValue("nonconvex-file", filenameNonConvex);
+  // obtain information
+  getParametersfromValueStorage();
 
   for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
@@ -81,13 +53,13 @@
     const LinkedCell *LCList = NULL;
     DoLog(0) && (Log() << Verbose(0) << "Evaluating volume of the convex envelope.");
-    DoLog(1) && (Log() << Verbose(1) << "Storing tecplot convex data in " << filenameConvex << "." << endl);
-    DoLog(1) && (Log() << Verbose(1) << "Storing tecplot non-convex data in " << filenameNonConvex << "." << endl);
-    LCList = new LinkedCell(mol, 100.);
-    Boundaries *BoundaryPoints = NULL;
+    DoLog(1) && (Log() << Verbose(1) << "Storing tecplot convex data in " << params.filenameConvex << "." << endl);
+    DoLog(1) && (Log() << Verbose(1) << "Storing tecplot non-convex data in " << params.filenameNonConvex << "." << endl);
+    LCList = new LinkedCell(*mol, 100.);
+    //Boundaries *BoundaryPoints = NULL;
     //FindConvexBorder(mol, BoundaryPoints, TesselStruct, LCList, argv[argptr]);
     // TODO: Beide Funktionen sollten streams anstelle des Filenamen benutzen, besser fuer unit tests
-    FindNonConvexBorder(mol, TesselStruct, LCList, 50., filenameNonConvex.c_str());
+    FindNonConvexBorder(mol, TesselStruct, LCList, 50., params.filenameNonConvex.c_str());
     //RemoveAllBoundaryPoints(TesselStruct, mol, argv[argptr]);
-    const double volumedifference = ConvexizeNonconvexEnvelope(TesselStruct, mol, filenameConvex.c_str());
+    const double volumedifference = ConvexizeNonconvexEnvelope(TesselStruct, mol, params.filenameConvex.c_str());
     const double clustervolume = VolumeOfConvexEnvelope(TesselStruct, configuration);
     DoLog(0) && (Log() << Verbose(0) << "The tesselated volume area is " << clustervolume << " " << (configuration->GetIsAngstroem() ? "angstrom" : "atomiclength") << "^3." << endl);
@@ -127,2 +99,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/TesselationAction/ConvexEnvelopeAction.def
===================================================================
--- src/Actions/TesselationAction/ConvexEnvelopeAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/TesselationAction/ConvexEnvelopeAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * ConvexEnvelopeAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class TesselationListClass;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string) (std::string)
+#define paramtokens ("convex-file") ("nonconvex-file")
+#define paramreferences (filenameConvex) (filenameNonConvex)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Tesselation
+#define ACTIONNAME ConvexEnvelope
+#define TOKEN "convex-envelope"
+
Index: src/Actions/TesselationAction/ConvexEnvelopeAction.hpp
===================================================================
--- src/Actions/TesselationAction/ConvexEnvelopeAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/TesselationAction/ConvexEnvelopeAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,30 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
 
-class TesselationListClass;
-
-void TesselationConvexEnvelope(std::string &filenameConvex, std::string &filenameNonConvex);
-
-class TesselationConvexEnvelopeAction : public Action {
-  friend void TesselationConvexEnvelope(std::string &filenameConvex, std::string &filenameNonConvex);
-
-public:
-  TesselationConvexEnvelopeAction();
-  virtual ~TesselationConvexEnvelopeAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "ConvexEnvelopeAction.def"
+#include "Action_impl_header.hpp"
 
 #endif // CONVEXENVELOPEACTION_HPP
Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * NonConvexEnvelopeAction.cpp
@@ -6,13 +13,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/TesselationAction/NonConvexEnvelopeAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "boundary.hpp"
 #include "linkedcell.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
-#include "verbose.hpp"
+#include "tesselation.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -22,55 +33,17 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/TesselationAction/NonConvexEnvelopeAction.hpp"
 
-/****** TesselationNonConvexEnvelopeAction *****/
-
-// memento to remember the state when undoing
-
-//class TesselationNonConvexEnvelopeState : public ActionState {
-//public:
-//  TesselationNonConvexEnvelopeState(molecule* _mol,std::string _lastName) :
-//    mol(_mol),
-//    lastName(_lastName)
-//  {}
-//  molecule* mol;
-//  std::string lastName;
-//};
-
-const char TesselationNonConvexEnvelopeAction::NAME[] = "nonconvex-envelope";
-
-TesselationNonConvexEnvelopeAction::TesselationNonConvexEnvelopeAction() :
-  Action(NAME)
-{}
-
-TesselationNonConvexEnvelopeAction::~TesselationNonConvexEnvelopeAction()
-{}
-
-void TesselationNonConvexEnvelope(double radius, std::string &filename) {
-  ValueStorage::getInstance().setCurrentValue(TesselationNonConvexEnvelopeAction::NAME, radius);
-  ValueStorage::getInstance().setCurrentValue("nonconvex-file", filename);
-  ActionRegistry::getInstance().getActionByName(TesselationNonConvexEnvelopeAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* TesselationNonConvexEnvelopeAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryDouble(NAME, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryString("nonconvex-file", MapOfActions::getInstance().getDescription("nonconvex-file"));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "NonConvexEnvelopeAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr TesselationNonConvexEnvelopeAction::performCall() {
-  string filename;
   molecule * Boundary = NULL;
-  double SphereRadius = 0;
   bool Success = false;
   clock_t start,end;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, SphereRadius);
-  ValueStorage::getInstance().queryCurrentValue("nonconvex-file", filename);
+  // obtain information
+  getParametersfromValueStorage();
 
   for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
@@ -79,10 +52,10 @@
     const LinkedCell *LCList = NULL;
     DoLog(0) && (Log() << Verbose(0) << "Evaluating non-convex envelope of molecule." << Boundary->getId() << endl);
-    DoLog(1) && (Log() << Verbose(1) << "Using rolling ball of radius " << SphereRadius << " and storing tecplot data in " << filename << "." << endl);
+    DoLog(1) && (Log() << Verbose(1) << "Using rolling ball of radius " << params.SphereRadius << " and storing tecplot data in " << params.filename << "." << endl);
     DoLog(1) && (Log() << Verbose(1) << "Specified molecule has " << Boundary->getAtomCount() << " atoms." << endl);
     start = clock();
-    LCList = new LinkedCell(Boundary, SphereRadius*2.);
-    Success = FindNonConvexBorder(Boundary, T, LCList, SphereRadius, filename.c_str());
-    //FindDistributionOfEllipsoids(T, &LCList, N, number, filename.c_str());
+    LCList = new LinkedCell(*Boundary, params.SphereRadius*2.);
+    Success = FindNonConvexBorder(Boundary, T, LCList, params.SphereRadius, params.filename.c_str());
+    //FindDistributionOfEllipsoids(T, &LCList, N, number, params.filename.c_str());
     end = clock();
     DoLog(0) && (Log() << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl);
@@ -121,2 +94,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.def
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * NonConvexEnvelopeAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class TesselationListClass;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (double) (std::string)
+#define paramtokens (TesselationNonConvexEnvelopeAction::NAME) ("nonconvex-file")
+#define paramreferences (SphereRadius) (filename)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Tesselation
+#define ACTIONNAME NonConvexEnvelope
+#define TOKEN "nonconvex-envelope"
+
